
;; define the package for all GECO code:

(defpackage GECO
  (:use "COMMON-LISP"
        #+:ccl-2 "CCL")
  (:nicknames "GA")
  (:EXPORT "2X-CROSS-CHROMOSOMES" "2X-CROSS-ORGANISMS" "ALLELE-CODE-TO-VALUE" "ALLELE-VALUES"
           "AS-GOOD-AS-TEST" "AVG-NORMALIZED-SCORE" "AVG-SCORE" "B2G-MAP"
           "BEST-ORGANISM" "BEST-ORGANISM-ACCESSOR"
           "BETTER-THAN-TEST" "BIN2GRAY" "BINARY-CHROMOSOME" "CHROMOSOME"
           "CHROMOSOME-CLASSES" "COMPILE-GECO"
           "COMPUTE-BINARY-ALLELE-STATISTICS"
           "COMPUTE-NORMALIZED-STATISTICS" "COMPUTE-STATISTICS"
           "CONVERGED-P" "CONVERGENCE-FRACTION"
           "CONVERGENCE-THRESHOLD-MARGIN" "COPY-CHROMOSOME"
           "COPY-CHROMOSOME-WITH-SCORE" "COPY-ORGANISM"
           "COPY-ORGANISM-WITH-SCORE" "COUNT-ALLELE-CODES"
           "CROSS-CHROMOSOMES" "CROSS-ORGANISMS" "DBG" "DBG-P" "DBG?"
           "DBGO" "DECODE" "DECODE-BINARY-LOCI-VALUE" "ECOSYSTEM"
           "EDIT-GECO" "EIDETIC" "EVALUATE" "EVALUATION-LIMIT"
           "EVALUATION-NUMBER" "EVOLUTION-TERMINATION-P" "EVOLVE" "G2B-MAP"
           "GECO-RANDOM-FLOAT" "GECO-RANDOM-INTEGER" "GENERATION-LIMIT"
           "GENERATION-NUMBER" "GENERATIONAL-POPULATION" "GENETIC-PLAN"
           "GENOTYPE" "GENOTYPE-PRINTABLE-FORM" "GRAY-CODE-TRANSLATION"
           "GRAY2BIN" "HAMMING-DISTANCE" "LOCI" "LOCI-PRINTABLE-FORM"
           "LOCUS" "LOCUS-ARITY" "LOCUS-PRINTABLE-FORM" "MAKE-CHROMOSOME"
           "MAKE-CHROMOSOMES" "MAKE-GENETIC-PLAN" "MAKE-LOCI-VECTOR"
           "MAKE-ORGANISM" "MAKE-ORGANISMS" "MAKE-POPULATION"
           "MAKE-POPULATION-STATISTICS" "MAKE-ORGANISMS-VECTOR"
           "MAX-ORGANISM"
           "MAX-SCORE" "MAXIMIZING-P" "MAXIMIZING-SCORE-MIXIN"
           "MIN-ORGANISM" "MIN-SCORE"
           "MINIMIZING-P" "MINIMIZING-SCORE-MIXIN" "MUTATE-CHROMOSOME"
           "MUTATE-ORGANISM" "NORMALIZE-SCORE" "NORMALIZED-SCORE"
           "NUMBER-OF-BITS" "ORGANISM" "ORGANISM-CLASS"
           "ORGANISM-PHENOTYPE-MIXIN" "ORGANISMS" "PARK-MILLER-RANDOMIZER"
           "PHENOTYPE" "PICK-LOCUS-INDEX" "PICK-RANDOM-ALLELE"
           "PICK-RANDOM-ALLELES" "PICK-RANDOM-CHROMOSOME"
           "PICK-RANDOM-CHROMOSOME-INDEX" "PICK-RANDOM-ORGANISM"
           "PICK-RANDOM-ORGANISM-INDEX" "PICK-SOME-RANDOM-ORGANISM-INDICES"
           "PLAN" "PMX-CROSS-CHROMOSOMES" "PMX-CROSS-ORGANISMS"
           "POPULATION" "POPULATION-STATISTICS"
           "POPULATION-STATISTICS-CLASS" "PRINTABLE-ALLELE-VALUES"
           "R3-CROSS-CHROMOSOMES" "R3-CROSS-ORGANISMS"
           "RANDOM-FLOATING-POINT-NUMBER" "RANDOM-INTEGER"
           "RANDOMIZE-CHROMOSOMES" "RANKING-PRESELECT" "REGENERATE"
           "ROULETTE-PICK-RANDOM-ORGANISM"
           "ROULETTE-PICK-RANDOM-ORGANISM-INDEX"
           "ROULETTE-PICK-RANDOM-WEIGHT-INDEX" "SCORE" "SCRAMBLE-ALLELES"
           "SEQUENCE-CHROMOSOME" "SIZE" "STATISTICS"
           "STOCHASTIC-REMAINDER-PRESELECT" "SUM-NORMALIZED-SCORE"
           "SUM-SCORE" "SWAP-ALLELES" "TOURNAMENT-SELECT-ORGANISM" "UNDBG"
           "UNIFORM-CROSS-CHROMOSOMES" "UNIFORM-CROSS-ORGANISMS"
           "WORST-ORGANISM" "WORST-ORGANISM-ACCESSOR")
  )

;; and a package for applications:

(defpackage GECO-USER
    (:use "COMMON-LISP"
          #+:ccl-2 "CCL"
          "GECO")
    (:nicknames "GU"))
